package li.cil.manual.client.manual.provider;

import betterwithmods.BWMod;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.mechanical.BlockCookingPot;
import betterwithmods.common.blocks.mechanical.BlockMechMachines;
import betterwithmods.common.blocks.mini.BlockMini;
import com.google.common.collect.Sets;
import li.cil.manual.api.manual.PathProvider;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;
import java.util.Set;
import java.util.function.BiFunction;

import static net.minecraft.block.material.Material.WOOD;

/**
 * Created by primetoxinz on 6/18/17.
 */
public class DefinitionPathProvider implements PathProvider {
    public static Set<ItemStack> blacklist = Sets.newHashSet(ItemStack.field_190927_a);

    BiFunction<World, IBlockState, String> customPath = (world, state) -> {
        Block block = state.func_177230_c();


        return null;
    };

    public static boolean isBlacklisted(ItemStack stack) {
        return blacklist.stream().anyMatch(s -> stack.func_77969_a(s));
    }

    @Nullable
    @Override
    public String pathFor(ItemStack stack) {
        if (isBlacklisted(stack) || !stack.func_77973_b().getRegistryName().func_110624_b().equals(BWMod.MODID))
            return null;
        String path = stack.func_77977_a().replace("item.bwm:", "");
        return "%LANGUAGE/items/" + path + ".md";
    }

    @Nullable
    @Override
    public String pathFor(World world, BlockPos pos) {
        IBlockState state = world.func_180495_p(pos);
        Block block = state.func_177230_c();
        int meta = block.func_180651_a(state);
        ItemStack stack = new ItemStack(block, 1, meta);
        if (isBlacklisted(stack) || !stack.func_77973_b().getRegistryName().func_110624_b().equals(BWMod.MODID))
            return null;
        if (block == BWMBlocks.PLANTER)
            return "%LANGUAGE%/blocks/planter.md";
//        if (block == BWMBlocks.BROKEN_GEARBOX)
//            return "%LANGUAGE%/blocks/gearbox.md";
        if (block instanceof BlockCookingPot) {
            return "%LANGUAGE%/blocks/" + state.func_177229_b(BlockCookingPot.TYPE).func_176610_l() + ".md";
        }
        if (block instanceof BlockMechMachines) {
            return "%LANGUAGE%/blocks/" + state.func_177229_b(BlockMechMachines.TYPE).func_176610_l() + ".md";
        }
        if (block instanceof BlockMini) {
            Material mat = block.func_149688_o(state);
            if (mat == field_151575_d || mat == BlockMini.MINI) {
                return "%LANGUAGE%/blocks/minimized_wood.md";
            }
        }
        String path = stack.func_77977_a().replace("tile.bwm:", "");
        return "%LANGUAGE%/blocks/" + path + ".md";
    }
}
